//***********************************************
//     program name: V64IO.C  version 1.0
//
// new expand control command for pc with v64
//
// every command leader code is 'GD6'
// read data from v64 code is 'ER' and fellow 8 bytes
//            s3,s2,s1,s0,l3,l2,l1,l0 and wait v64 send 0xa0 confirm
//            and read lxxxx length data from v64
// write data to v64 code is 'EW' and fellow 8 bytes
//            s3,s2,s1,s0,l3,l2,l1,l0 and wait v64 send 0xa1 confirm
//            and send lxxxx length data to v64
// *** s3,s2,s1,s0=>address area
//                (s3's D7=0(256Mb dram),
//                      D7=1(only 0200~07ff cpu area in write mode,
//                           0000~ffff cpu area except c000~cfff in read mode
// *** l3,l2,l1,l0=>data length-1
//
//
//
// call function code is 'EC' and fellow 2 bytes
//            adrh,adrl(0000~ffff cpu address) and wait v64 send 0xa2 confirm
//
// print function code is 'EP' and fellow 2 bytes
//            row(0~0x0a),col(0~0x17) and wait v64 send 0xa3 confirm
//            send ascii string "xxxxxxx" and terminated code is 0xff
//            (d7=0 normal char. d7=1 flash char.)
//            (d6=0 most part of ascii code, d6=1 (0~0x7f)nec6450 OSD code)


extern int in32k(int *,int,int);
extern int out32kx(int *,int,int,int);
/* out32k(&buffer,read_length,port_adr,com_mode)
com_mode=0 is old mode(use SLCT_IN,AUTO.FX)
com_mode=1 is new mode(use ERROR,SLCT)
return code=0 is ok, other code is error */
#include <dos.h>
#include <stdio.h>
#include <stdlib.h>
#include <io.h>
#include <dir.h>
#include <string.h>

#define error 8
#define busy 0x80
#define stb_hi 0x04
#define stb_lo 0x05
#define space 0x20
#define trans_size 32768
#define loop_cnt 8192

char com_mode;
unsigned int port[4],port_adr,port_adr1,port_adr2;
int max_port,sel_port,no,number_of_32k,action_flag,keyin_code;
char command_line[128],command_len,command_ptr;
char string[4][128],string3_len,code_err,code1_err,code2_err;
unsigned long int code1,code2,dig_num,total_num;
char file_name[128],error_code,flag;
char org_file[MAXFILE];
char drive[MAXDRIVE],dir[MAXDIR],file[MAXFILE],ext[MAXEXT];
FILE *fptr;
long file_len;
unsigned char buffer[32768];
unsigned char small_buffer[128];
struct ffblk fblock;
div_t x;





/**************************************
*               Subroutine            *
**************************************/
int disp_buffer(unsigned int disp_st,unsigned int disp_len)
{
   int i,j,x,y;
   if (disp_len==0) return (-1);
   i=disp_st;
   if ((i&0xf)!=0)
      {
      printf("%04x : ",i);
      for (j=0;j<(i&0xf);j++)
	 {
	 printf("   ");
	 if (j==7 & (i&0xf)!=8)
	    printf("- ");
	 }
      }
   for (i=disp_st; i<(disp_st+disp_len) ; i++)
      {
      if ((i & 0xf)==0)
	 printf("%04x : ",i&0x7ff0);
      if ((i & 0xf)==8)
	 printf("- ");
      printf("%02x ",buffer[i]);
      if ((i & 0xf)==0xf)
	 {
	 printf("-> ");
	 for (j=0; j<16 ; j++)
	    {
	    if (buffer[(i&0x7ff0)+j]<0x20 || buffer[(i&0x7ff0)+j]>0x80)
	       printf (".");
	    else
	       printf ("%c",buffer[(i&0x7ff0)+j]);
	    }
	 printf("\n");
	 }
      }

//   y=disp_len&0xf;
   y=(disp_st+disp_len)&0xf;
   if (y)				/* not equal 16*?? */
      {
      for (x=y;x<16;x++)
	 {
	 if ((x & 0xf)==8)
	    printf("- ");
	 printf("   ");
	 if ((x & 0xf)==0xf)
	    {
	    printf("-> ");
	    for (j=0; j<y ; j++)
	       {
	       if (buffer[(i&0x7ff0)+j]<0x20 || buffer[(i&0x7ff0)+j]>0x80)
		  printf (".");
	       else
		  printf ("%c",buffer[(i&0x7ff0)+j]);
	       }
	    printf("\n");
	    }
	 }
      }
   return(0);
}


void port_select(void)
{
sel_port=1;			/* set default to port 1 */
if (max_port > 1)
   {
   printf("Please input download printer port no (1-%d) : ",max_port);
   sel_port=getch();
   if(sel_port!='\r')   /* press 'Enter' */
      {
      if(sel_port<'1' || sel_port>(max_port+'0'))
	 {
	 printf("no this port, error!!!\07\n");
	 exit(-1);
	 }
      sel_port=sel_port-'0';
      printf("%x\n",sel_port);
      }
   else
      {
      printf("1\n");
      sel_port=1;
      }
   }
/*
printf("commucation port is %04x\n",port_adr);
*/
}

void port_ext(void)
{
printf("port select is : ");
if (max_port > 1)
   {
   if(sel_port<1 || sel_port>(max_port))
      {
      printf("no this port, error!!!\07\n");
      exit(-1);
      }
   printf("%x\n",sel_port);
   }
else
   {
   sel_port=1;
   printf("1\n");
   }
}

void init_port(void)
{
port_adr=port[sel_port];
port_adr1=port_adr+1;
port_adr2=port_adr+2;
outportb(port_adr2,stb_hi);		/* init port */
}


int sync_header_old(void)	/* old mode use(slct_in,auto.fx) */
{
int i;
i=0;

while (i<loop_cnt)
   {
   if ((inportb(port_adr2)&8)==0) /* inverse slct_in = 1 */
      {
      outportb(port_adr,0xaa);
      outportb(port_adr2,0);			/* set init-> ~~~~~~|_______ */
      while (i<loop_cnt)
	 {
	 if (inportb(port_adr2)&8)    	/* inverse slct_in = 0 */
	    {
	    outportb(port_adr2,4);		/* set init->  ______|~~~~~~~ */
	    while (i<loop_cnt)
	       {
	       if ((inportb(port_adr2)&8)==0) /* inverse slct_in = 1 */
		  {
		  outportb(port_adr,0x55);	/* old mode use(slct_in,auto.fx) */
		  outportb(port_adr2,0);  	/* set init-> ~~~~~~|_______ */
		  while (i<loop_cnt)
		     {
		     if (inportb(port_adr2)&8)  /* inverse slct_in = 0 */
			{
			outportb(port_adr2,4);  /* set init->  ______|~~~~~~~ */
			while (i<loop_cnt)
			   {
			   if ((inportb(port_adr2)&8)==0)     /* inverse slct_in = 1 */
			      return(0);			/* sync ok */
			   i++;
			   }
			}
		     i++;
		     }
		  }
	       i++;
	       }
	    }
	 i++;
	 }
      }
   i++;
   }
outportb(port_adr2,4);
outportb(port_adr,0);
com_mode=1;		/* use new com mode */
return(-1);
}

int sync_header_new(void)	/* new mode use(error,slct) */
{
int i;
i=0;

while (i<loop_cnt)
   {
   if (inportb(port_adr1)&8) 		/* error = 1 */
      {
      outportb(port_adr,0xa5);
      outportb(port_adr2,0);		/* set init-> ~~~~~~|_______ */
      while (i<loop_cnt)
	 {
	 if (!(inportb(port_adr1)&8))  	/* error = 0 */
	    {
	    outportb(port_adr2,4);		/* set init->  ______|~~~~~~~ */
	    while (i<loop_cnt)
	       {
	       if (inportb(port_adr1)&8) /* error = 1 */
		  {
		  outportb(port_adr,0x5a);	/* old mode use(slct_in,auto.fx) */
		  outportb(port_adr2,0);  	/* set init-> ~~~~~~|_______ */
		  while (i<loop_cnt)
		     {
		     if (!(inportb(port_adr1)&8))  /* error = 0 */
			{
			outportb(port_adr2,4);  /* set init->  ______|~~~~~~~ */
			while (i<loop_cnt)
			   {
			   if (inportb(port_adr1)&8)     /* error = 1 */
			      return(0);		 /* sync ok */
			   i++;
			   }
			}
		     i++;
		     }
		  }
	       i++;
	       }
	    }
	 i++;
	 }
      }
   i++;
   }
outportb(port_adr2,4);
outportb(port_adr,0);
com_mode=0;		/* use old com mode */
return(-1);
}

int sync_header(void)
{
/* port_adr2:d0->stb, d1->auto.fx, d2->init, d3->slct_in */
/* port_adr1:d7->busy, d6->ack, d5->pe, d4->slct, d3->error */
   outportb(port_adr2,4);                  /* set stb,auto,init,slct=high */
   if (com_mode)
      return(sync_header_new());	/* new mode use(error,slct) */
   else
      return(sync_header_old());	/* old mode use(slct_in,auto.fx) */
}




void get_port(void)
{
   int i;
   port[1]=mem_value(8);
   port[2]=mem_value(10);
   port[3]=mem_value(12);
   port[4]=mem_value(14);
   max_port=0;		/* init max. port is 0 */
   for (i=1;i<5;i++)
      {
      if (port[i]==0) break;
      max_port=i;
      printf("port%d = %x\n",i,port[i]);
      if (i<4)
	 if (port[i]==port[i+1]) break;
      }
   printf("\n");
}

int mem_value(offset)
{
unsigned char far *ptr,ptr_low;
unsigned int ptr_high;
ptr = (char far *)0x400;
ptr_low=*(ptr+offset);
ptr_high=(*(ptr+offset+1))<<8 | ptr_low;
return(ptr_high);
}

int in_data(void)
{
   return(in32k(&small_buffer,1,port_adr));
}

int out_data(unsigned char data)
{
   small_buffer[0]=data;
   return(out32kx(&small_buffer,1,port_adr2,com_mode));
}

void flip_action(void)
{
   int tmp;
   action_flag++;
   tmp=action_flag;
   x=div(tmp,5);
   switch (x.rem)
      {
      case 0:printf("|");
	 break;
      case 1:printf("/");
	 break;
      case 2:printf("-");
	 break;
      case 3:printf("|");
	 break;
      case 4:printf("\\");
	 break;
      }
   printf("\x08");			/* backspce */
}


int send_expand_header(unsigned code)
{
   int temp;
   strcpy(small_buffer,"GD6E");		// GD6ER/GD6EW/GD6EC/GD6EP
   small_buffer[4]=code;
   temp=(out32kx(&small_buffer,5,port_adr2,com_mode));   /* link header 'GD6E' */
   if (temp)
      printf("send expand header error\07\n");
   return(temp);
}

int check_sync(void)
{
int i,j;
for (i=0;i<loop_cnt;i++)
   {
      if (((inportb(port_adr2)&3)==3 || (inportb(port_adr2)&3)==0) && com_mode==0)
	 {
	 outportb(port_adr,0);	/* set D7=0 */
	 for (j=0;j<loop_cnt;j++)
	    {
	    if ((inportb(port_adr1)&0x80)==0)	// check busy
	       {
/*	    outportb(port_adr,0x80);		/* set D7=0 */
	       return(0);
	       }
	    }
	 return(-1);
	 }
      if (((inportb(port_adr2)&1)^((inportb(port_adr1)&0x10)>>4)) && com_mode==1)	// new mode
	 {
	 outportb(port_adr,0);	/* set D7=0 */
	 for (j=0;j<loop_cnt;j++)
	    {
	    if ((inportb(port_adr1)&0x80)==0)	// check busy
	       {
/*	    outportb(port_adr,0x80);		/* set D7=0 */
	       return(0);
	       }
	    }
	 return(-1);
	 }
   }
return(-1);
}

int check_in_code(void)
{
   int delay_loop;
   if (check_sync())		/* sync busy & D7 */
      {
      printf("Sync busy error!\07\n");
      return(-1);
      }
   if (in_data())
      {
      printf("can't recived data!\07\n");
      return(-1);
      }
   if (com_mode)
      for (delay_loop=0;delay_loop<0x4000;delay_loop++);
   return(0);
}

int read_function(void)			// every 32k overlap
{
   unsigned long i;
   while (sync_header())
      {
      if (kbhit())
	 if (getch()==0x1b)
	    return(-1);
      flip_action();
      }
   if (send_expand_header('R')!=0)	 // send "GD6E"
      return(-1);
   small_buffer[0]=(code1>>24)&0xff;
   small_buffer[1]=(code1>>16)&0xff;
   small_buffer[2]=(code1>>8)&0xff;
   small_buffer[3]=code1&0xff;
   small_buffer[4]=(code2>>24)&0xff;
   small_buffer[5]=(code2>>16)&0xff;
   small_buffer[6]=(code2>>8)&0xff;
   small_buffer[7]=code2&0xff;
   if (out32kx(&small_buffer,8,port_adr2,com_mode))
      {
      printf("send adr error !!!\07\n");
      return(-1);
      }
   i=code2;
   if (check_in_code()) return(-1);
   if (small_buffer[0]!=0xa0)
      {
      printf("read function not accept!\07\n");
      return(-1);
      }
   while (i)
      {
      if (i<=0x8000)
	 {
	 if (in32k(&buffer,i,port_adr)!=0)
	    {
	    printf("recive error !!!\07\n");
	    return(-1);
	    }
	 i=0;
	 }
      else
	 {
	 if (in32k(&buffer,0x8000,port_adr)!=0)
	    {
	    printf("recive error !!!\07\n");
	    return(-1);
	    }
	 printf(".");		// every '.' is 32k
	 i=i-0x8000;
	 }
      }
   printf("read ok\n");
   return(0);
}

int write_function(void)		// every 32k overlap
{
   unsigned long i;
   while (sync_header())
      {
      if (kbhit())
	 if (getch()==0x1b)
	    return(-1);
      flip_action();
      }
   if (send_expand_header('W'))	 // send "GD6E"
      return(-1);
   small_buffer[0]=(code1>>24)&0xff;
   small_buffer[1]=(code1>>16)&0xff;
   small_buffer[2]=(code1>>8)&0xff;
   small_buffer[3]=code1&0xff;
   small_buffer[4]=(code2>>24)&0xff;
   small_buffer[5]=(code2>>16)&0xff;
   small_buffer[6]=(code2>>8)&0xff;
   small_buffer[7]=code2&0xff;
   if (out32kx(&small_buffer,8,port_adr2,com_mode))
      {
      printf("send adr error !!!\07\n");
      return(-1);
      }
   i=code2;
   if (check_in_code()) return(-1);
   if (small_buffer[0]!=0xa1)
      {
      printf("write function not accept!\07\n");
      return(-1);
      }
   while (i)
      {
      if (i<=0x8000)
	 {
	 if (out32kx(&buffer,i,port_adr2,com_mode)!=0)
	    {
	    printf("write error !!!\07\n");
	    return(-1);
	    }
	 i=0;
	 }
      else
	 {
	 if (out32kx(&buffer,0x8000,port_adr2,com_mode)!=0)
	    {
	    printf("write error !!!\07\n");
	    return(-1);
	    }
	 printf(".");		// every '.' is 32k
	 i=i-0x8000;
	 }
      }
   printf("write ok\n");
   return(0);
}

int call_function(void)
{
   unsigned char temp;
   if (code1>0xffff)
      {
      printf("address >0xffff error!\07\n");
      return(-1);
      }
   while (sync_header())
      {
      if (kbhit())
	 if (getch()==0x1b)
	    return(-1);
      flip_action();
      }
//   printf("retcode=%x\n",send_expand_header('C')); // send "GD6EC"
   if(send_expand_header('C')) 	  // send "GD6EC"
      return(-1);
   if (out_data((code1>>8)&0xff)) // hi-address
      {
      printf("send hi-address error in call function\07\n");
      return(-1);
      }
   if (out_data(code1&0xff))      // lo-address
      {
      printf("send lo-address error in call function\07\n");
      return(-1);
      }
   if (check_in_code()) return(-1);
   if (small_buffer[0]!=0xa2)
      {
      printf("Call function not accept!\07\n");
      return(-1);
      }
   return(0);
}

int print_function()
{
   int i;
   if ((code1&0xf)>0xa)
      {
      printf("row address error\07\n");
      return(-1);
      }
   if ((code2&0x1f)>0x17)
      {
      printf("col address error\07\n");
      return(-1);
      }
   while (sync_header())
      {
      if (kbhit())
	 if (getch()==0x1b)
	    return(-1);
      flip_action();
      }
   if (send_expand_header('P'))  // send "GD6EP"
      return(-1);
   if (out_data(code1&0xef)) 	 // row address
      {
      printf("send row address error in print function\07\n");
      return(-1);
      }
   if (out_data(code2&0x1f))     // col address
      {
      printf("send clo address error in print function\07\n");
      return(-1);
      }
   if (check_in_code()) return(-1);
   if (small_buffer[0]==0xa3)
      {
      for(i=0;i<string3_len;i++)
	 buffer[i]=string[3][i];
      if (out32kx(&buffer,string3_len,port_adr2,com_mode)!=0)
	 {
	 printf("write error !!!\07\n");
	 return(-1);
	 }
      }
   else
      {
      printf("Print function not accept!\07\n");
      return(-1);
      }
   return(0);
}

void dump_data(void)
{
// in this demo limited buffer is 32k,data display may be ovelap
   if(disp_buffer(code1&0x7fff,code2&0x7fff))
      printf("length error\07\n");
}


int save_file(void)
{
/*-------------- open a file for write ----------*/
   if ((fptr=fopen(string[2],"w+b"))==NULL)
      {
      printf("open write file error !!!\07\n");
      return(-1);
      }
   else
      {
/*-------------- write data to file ----------*/
      if (fwrite((char *)buffer,sizeof(char),code1,fptr)!=code1)
	 {
	 fclose(fptr);
	 printf("write file error !!!\07\n");
	 return(-1);
	 }
      }
/*---------------- close file -------------*/
   fclose(fptr);
   return(0);
}

int load_file(void)
{
   if((fptr=fopen(string[1],"rb"))==NULL)
      {				/* open error */
      printf("open file error !!!\07\n");
      return(-1);
      }
   file_len=(fread((char *)buffer,sizeof(char),0x8000,fptr));
   if (!file_len)
      {
      printf("read file data error!!!\07\n");
      fclose(fptr);	/* read data error */
      return(-1);
      }
   printf("load %x data ok!\n",file_len);
   fclose(fptr);
   return(0);
}


void chr2hex(int code,int pos)
{
   unsigned long int temp;
   temp=0;
   dig_num=0;
   if (code>0x2f && code<0x3a)		// 0~9
      temp=code & 0xf;
   else
      if (code>0x40 && code<0x47)		// A~F
	 temp=(code & 0xf)+9;
      else
	 {
	 code_err=1;
	 total_num=0;
	 }

   dig_num=temp<<(pos*4);
}


int str2hex(char str[128])
{
   int len,i,j;
   code_err=0;
   total_num=0;
   len=strlen(str);
   if (len>8 || len<1)
      return(0);  // not grate 8 bytes or less than 1 byte

   j=len-1;
   for (i=0;i<len;i++)
      {
      chr2hex(str[i],j);
      total_num=dig_num+total_num;
      j--;
      }
   return(0);
}


char keyin_hex(char src)
{
   char code;
   code=src&0xf;
   if (isalpha(src))
      code=code+9;		// a~f
   return(code);
}

int edit_keyin(int data)
{
   char chr,c[2],index; 	// keyin data
   index=0;			// no of keyin data
   keyin_code=data;  			// converted keyin data
   c[0]=0;
   c[1]=0;

   while (index<2)
      {
      chr=getch();
      if (isxdigit(chr))
	 {
	 putch(chr);
	 c[index]=chr;
	 keyin_code=keyin_hex(c[0]);
	 if (index==1)
	    keyin_code=keyin_code*16+keyin_hex(c[1]);
	 index++;
	 }
      if (chr==0x20)          // keyin sapce
	 {
	 switch (index)
	    {
	    case 0:printf("  ");break;
	    case 1:printf(" ");break;
	    }
	 return(1);
	 }
      if (chr==0x0d)          // keyin return key
	 return(2);
      }
   return(0);			// input two data
}

void edit_data(void)
{
   char new_data,c;
   int adr,len;
   code_err=0;
   total_num=0;
   adr=code1&0x7fff;
      printf("%04x   ",adr);		// print address
   while(1)
      {
      printf("%02x.",buffer[adr]);
      if (edit_keyin(buffer[adr])==2)	// press return
	 {
	 printf("\n");
	 buffer[adr]=keyin_code;
	 break;
	 }
      else
	 {
	 printf("  ");
	 buffer[adr]=keyin_code;
	 }
      adr=(adr+1)&0x7fff;
      if (!(adr&7))
	 printf("\n%04x   ",adr);	// print new address
      }
}


int packing(void)
{
   int i,j,ptr,len;
   len=strlen(command_line);	// get command line length
   ptr=0;			// command pointer
   for (j=0;j<3;j++)
      {
      i=0;
      while(ptr<len)
	 {
	 if (command_line[ptr]==' ')
	    {
	    ptr++;
	    break;
	    }
	 string[j][i]=command_line[ptr];
	 ptr++;
	 i++;
	 }
   string[j][i]=0;	// string end code
      }
   i=0;
   while(ptr<len)
      {
      string[j][i]=command_line[ptr];
      ptr++;
      i++;
      }
   string[3][i]=0xff;	// string end code for v64
   string3_len=i+1;
   strupr(string[0]);
   strupr(string[1]);
   strupr(string[2]);
   str2hex(string[1]);
   code1=total_num;
   code1_err=code_err;
   str2hex(string[2]);
   code2=total_num;
   code2_err=code_err;
//   printf("code1=%lx code2=%lx\n",code1,code2);
   return(0);
}

void help(void)
{
printf("REMARK:this demo version buffer size just 32k\n");
printf("       address/length is hex\n");
printf("       load/save/dump point to buffer address 0000\n");
printf("       read/write/call address is point to V64 address\n");
printf("       read/write data length is point to buffer \n\n");
printf("read  xxxx yyyy      (xxxx is starting address, yyyy is data length)\n");
printf("write xxxx yyyy      (xxxx is starting address, yyyy is data length)\n");
printf("call  xxxx           (xxxx is address(range is 0~ffff))\n");
printf("print xxxx yyyy zzzz (xxxx is row no(0~0x0a) (d7=0 normal d7=1 flash char.)\n");
printf("		     ,yyyy col. no(0~0x17), zzzz char string)\n");
printf("load  xxxx           (xxxx is filename)\n");
printf("save  xxxx yyyy      (xxxx is file length, yyyy is filename)\n");
printf("dump  xxxx yyyy      (xxxx is starting address, yyyy is data length)\n");
printf("edit  xxxx           (xxxx is address 'space' for next,'return' for end)\n");
}

/*************************************************
*                  MAIN ENTRY                    *
*************************************************/
void main(void)
{
   com_mode=0;			// default use old com_mode
   get_port();
   printf("---------- PC to V64 remote control program version 2.0 ----------\n");
   if (max_port==0)
      {
      printf("no printer port can be use !!!\n");
      exit(-1);
      }
   port_select();	/* no fellow parameter */
   /* prompt to select what is the port will be use */

   init_port();
/************** main command entry loop ***************/
   while(1)
      {
      printf("\n");
      if (com_mode)
	 printf("*");
      printf("[read/write/call/print/dump/edit/load/save/help/quit]\n");
      printf("command>");
      gets(command_line);
      packing();
      if (strcmp(string[0],"QUIT")==0) exit(0);
      if (strcmp(string[0],"HELP")==0) help();
      if (strcmp(string[0],"LOAD")==0) load_file();
      if (strcmp(string[0],"SAVE")==0) save_file();
      if (!code1_err)
	 {
	 if (strcmp(string[0],"CALL")==0) call_function();
	 if (strcmp(string[0],"EDIT")==0) edit_data();
	 }
      if (!(code1_err+code2_err))
	 {
	 if (strcmp(string[0],"READ")==0) read_function();
	 if (strcmp(string[0],"WRITE")==0) write_function();
	 if (strcmp(string[0],"PRINT")==0) print_function();
	 if (strcmp(string[0],"DUMP")==0) dump_data();
	 }
      }

}

